
import jpcap.*;
import jpcap.packet.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
class Tcpdump implements PacketReceiver {
	//global variables because im lazy
	public static String ip;
	public static XKCDMap map = new XKCDMap();;
	public static NetworkInterface[] devices = JpcapCaptor.getDeviceList();
	public static CardLayout cardLayout;
	public static JFrame frame = new JFrame();
	public static Tcpdump dump = new Tcpdump();
	public static int choice = 0;
	//Main!
	public static void main(String[] args){

		cardLayout = new CardLayout();
		frame.setPreferredSize(new Dimension(780, 795));
		frame.pack();
		frame.getContentPane().setLayout(cardLayout);
		frame.getContentPane().add(new NetworkPanel(new ActionListener(){
			public void actionPerformed(ActionEvent e)
			{	
				 cardLayout.last(frame.getContentPane());
				 frame.repaint();
				 choice = Integer.valueOf(((JButton)e.getSource()).getText());
				 (new Thread(new Runnable() {public void run() {initSniffer(choice);}})).start();
			}
		}, devices), "network");
		frame.getContentPane().add(map, "Map");
		frame.setVisible(true);
		frame.setResizable(false);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
	}
	// required for PacketReceiver
	public void receivePacket(Packet packet) {
		String pack = packet.toString();
		String hostip = "";
		try
		{
		if (!pack.contains("ARP") && pack.contains("/"))
		{
			hostip = pack.split("->")[0].split("/")[1];

		if (!pack.contains(ip))
				map.addIP(hostip, true);
			else if (!hostip.startsWith(ip.substring(0,8)))
				map.addIP(hostip, false);
		}
		}
		catch(Exception e)
			{System.out.println(e);}
	}
	

	//Called when a network interface is chosen
	public static void initSniffer(int num)
	{
		try{
			JpcapCaptor jpcap = JpcapCaptor.openDevice(devices[num], 2000, false, 20);
			ip = devices[num].addresses[0].address.toString().split("/")[1];
			jpcap.loopPacket(-1, dump);
			}catch(Exception e){System.out.println(e);}
	}
}

