
import javax.swing.*;
import javax.swing.Timer;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
public class XKCDMap extends JPanel
{
	private int map[][] = {{0,1,14,15,16,19,20,21,234,235,236,239,240,241,254,255},
			{3,2,13,12,17,18,23,22,233,232,237,238,243,242,253,252},
			{4,7,8,11,30,29,24,25,230,231,226,225,244,247,248,251},
			{5,6,9,10,31,28,27,26,229,228,227,224,245,246,249,250},
			{58,57,54,53,32,35,36,37,218,219,220,223,202,201,198,197},
			{59,56,55,52,33,34,39,38,217,216,221,222,203,200,199,196},
			{60,61,50,51,46,45,40,41,214,215,210,209,204,205,194,195},
			{63,62,49,48,47,44,43,42,213,212,211,208,207,206,193,192},
			{64,67,68,69,122,123,124,127,128,131,132,133,186,187,188,191},
			{65,66,71,70,121,120,125,126,129,130,135,134,185,184,189,190},
			{78,77,72,73,118,119,114,113,142,141,136,137,182,183,178,177},
			{79,76,75,74,117,116,115,112,143,140,139,138,181,180,179,176},
			{80,81,94,95,96,97,110,111,144,145,158,159,160,161,174,175},
			{83,82,93,92,99,98,109,108,147,146,157,156,163,162,173,172},
			{84,87,88,91,100,103,104,107,148,151,152,155,164,167,168,171},
			{85,86,89,90,101,102,105,106,149,150,153,154,165,166,169,170}};
	private final int WIDTH = 768;
	private final int HEIGHT = 768;
	private URL url;
	private ArrayList<Dot> points = new ArrayList();
	private Image img = null;
	public JLabel label;
	public XKCDMap()
	{
		super();
		try{
		url = getClass().getResource("map.gif");
		}catch(Exception e){System.out.println(e);}

		img = Toolkit.getDefaultToolkit().getImage(url);
		ImageIcon ico = new ImageIcon(img);		
		
		label = new JLabel(ico)
		{
			public void paintComponent(Graphics g)
			{
				g.drawImage(img, 0, 0, Color.white, this);
				g.setColor(Color.yellow);

				try{
				for (Dot p : (ArrayList<Dot>)points.clone())
				{
					if (p.foreign)
						g.setColor(Color.red);
					else
						g.setColor(Color.yellow);
					g.fillOval(p.x, p.y, p.rad, p.rad);
					if (p.done)
						points.remove(p);
				}
				}catch(Exception e){;}
			}	
		};
		add(label);
		setSize(new Dimension(WIDTH, HEIGHT));
		setPreferredSize(new Dimension(WIDTH, HEIGHT));
		timer.start();
	}
	public void addIP(String ip, boolean foreign)
	{
		Dot temp = getCoords(ip,foreign);
		if (!points.contains(temp))
			points.add(temp);
		repaint();
	}
	public Dot getCoords(String ip, boolean foreign)
	{
		Dot ret = null;
		int first = Integer.valueOf(ip.split("\\.")[0]);
		int second = Integer.valueOf(ip.split("\\.")[1]);
		int third = Integer.valueOf(ip.split("\\.")[2]);
		int x = 0, y = 0, tx = 0, ty = 0, x3 = 0, y3 = 0;
		for (int i = 0; i < 16; i++)
			for (int j = 0; j < 16; j++)
			{
				if (map[i][j] ==  first)
				{
					x = j; y = i;
				}
				if (map[i][j] == second)
				{
					tx = j; ty = i;
				}
				if (map[i][j] == third)
				{
					x3 = j; y3 = i;
				}
			}
		return new Dot((x*48)+(tx*3)+(x3/5),(y*48)+(ty*3)+(y3/5), foreign);
	}
	public Timer timer = new Timer(100, new ActionListener(){
		public void actionPerformed(ActionEvent e)
		{
			Dot p;
			for (int i =0; i < points.size(); i++)
			{p = points.get(i);
				if (p.rad >= 10)
				p.inc = -2;
			if (p.rad <= 0)
			{
				p.done = true;
				p.destroy();
			}
			p.x -= p.inc/2;
			p.y -= p.inc/2;
			p.rad += p.inc;
			label.repaint();
		}}
	});

	private class Dot extends Point implements Comparable<Dot>
	{
		public int rad = 2;
		public int inc = 2;
		public boolean done = false;
		private int x0, y0;
		public boolean foreign;
		
		public Dot(int x, int y, boolean f)
		{
			super(x, y);
			x0 = x;
			y0 = y;
			foreign = f;
		}
		public void destroy()
		{
			try{
				
			this.finalize();
			}
			catch(Throwable e2){;}

		}
		public int compareTo(Dot o)
		{
			if (o.x0 == x0 && o.y0 == y0)
				return 1;
			return 0;
		}
	}
 
}